var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from "react";
import PropTypes from "prop-types";

import { isEqualProps } from "../internal/Utils";
import { MapContext } from "../internal/MapContext";

/**
 * Sets the `viewport` to contain the given `bounds`.
 *
 * **Usage:**
 *
 * ```javascript
 * import React from "react";
 * import { GoogleMap, FitBounds } from "react-google-map-components"
 *
 * export default function GoogleMapWrapper(props) {
 *   return (
 *     <GoogleMap {...props} maps={google.maps}>
 *       <FitBounds latLngBounds={props.bounds} />
 *     </GoogleMap>
 *   );
 * }
 * ```
 *
 * **Google Maps Docs:**
 * * [google.maps.Map](https://developers.google.com/maps/documentation/javascript/reference#Map)
 */
export var FitBounds = function (_React$Component) {
  _inherits(FitBounds, _React$Component);

  function FitBounds() {
    _classCallCheck(this, FitBounds);

    return _possibleConstructorReturn(this, (FitBounds.__proto__ || Object.getPrototypeOf(FitBounds)).apply(this, arguments));
  }

  _createClass(FitBounds, [{
    key: "componentWillMount",
    value: function componentWillMount() {
      this.animate();
    }
  }, {
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate(nextProps) {
      return !isEqualProps(this.props.latLngBounds, nextProps.latLngBounds);
    }
  }, {
    key: "componentWillUpdate",
    value: function componentWillUpdate(nextProps) {
      this.animate(nextProps);
    }
  }, {
    key: "animate",
    value: function animate() {
      var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.props,
          latLngBounds = _ref.latLngBounds;

      var mapContext = this.context.mapContext;


      mapContext.map.fitBounds(mapContext.createLatLngBounds(latLngBounds));
    }
  }, {
    key: "render",
    value: function render() {
      return null;
    }
  }]);

  return FitBounds;
}(React.Component);

FitBounds.contextTypes = {
  mapContext: PropTypes.instanceOf(MapContext).isRequired
};

/* istanbul ignore else */
if (process.env.NODE_ENV !== "production") {
  FitBounds.propTypes = {
    /**
     * Array of positions that will be used to generate `LatLngBounds` object.
     *
     * See also: [google.maps.LatLngBounds](https://developers.google.com/maps/documentation/javascript/3.exp/reference#LatLngBounds)
     */
    latLngBounds: PropTypes.arrayOf(PropTypes.shape({
      /**
       * The latitude in degrees.
       */
      lat: PropTypes.number.isRequired,
      /**
       * The longitude in degrees.
       */
      lng: PropTypes.number.isRequired
    })).isRequired
  };
}