var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

import React from "react";
import PropTypes from "prop-types";
import { MapContext } from "../internal/MapContext";

export function withMapInstance() {
  return function (BaseComponent) {
    WithMapInstance.contextTypes = {
      mapContext: PropTypes.instanceOf(MapContext).isRequired
    };

    function WithMapInstance(props, context) {
      return React.createElement(BaseComponent, _extends({}, props, { map: context.mapContext.map }));
    }

    return WithMapInstance;
  };
}