"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ScaleControl = ScaleControl;

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _Control = require("./Control");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Controls display options of Scale control.
 *
 * **Usage:**
 *
 * ```javascript
 * import React from "react";
 * import { GoogleMap, ScaleControl } from "react-google-map-components"
 *
 * export default function GoogleMapWrapper(props) {
 *   return (
 *     <GoogleMap {...props} maps={google.maps}>
 *       <ScaleControl />
 *     </GoogleMap>
 *   );
 * }
 * ```
 *
 * **Google Maps Docs:**
 * * [google.maps.ScaleControlOptions](https://developers.google.com/maps/documentation/javascript/reference#ScaleControlOptions)
 */
function ScaleControl() {
  return _react2.default.createElement(_Control.Control, { name: "scaleControl" });
}