"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.MapContext = undefined;

var _get2 = require("lodash/get");

var _get3 = _interopRequireDefault(_get2);

var _has2 = require("lodash/has");

var _has3 = _interopRequireDefault(_has2);

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var MapContext = exports.MapContext = function () {
  function MapContext(map, maps) {
    _classCallCheck(this, MapContext);

    this.map = map;
    this.maps = maps;
  }

  _createClass(MapContext, [{
    key: "createPoint",
    value: function createPoint(point) {
      return new this.maps.Point(point.x, point.y);
    }
  }, {
    key: "createSize",
    value: function createSize(size) {
      return new this.maps.Size(size.width, size.height);
    }
  }, {
    key: "createLatLng",
    value: function createLatLng(latLng) {
      return new this.maps.LatLng(latLng);
    }
  }, {
    key: "createLatLngBounds",
    value: function createLatLngBounds(latLngBounds) {
      var _this = this;

      return latLngBounds.reduce(function (acc, x) {
        return acc.extend(_this.createLatLng(x));
      }, new this.maps.LatLngBounds());
    }
  }, {
    key: "createIcon",
    value: function createIcon(options) {
      var icon = { url: options.url };

      if (options.anchor) {
        icon.anchor = this.createPoint(options.anchor);
      }

      if (options.labelOrigin) {
        icon.labelOrigin = this.createPoint(options.labelOrigin);
      }

      if (options.origin) {
        icon.origin = this.createPoint(options.origin);
      }

      if (options.scaledSize) {
        icon.scaledSize = this.createSize(options.scaledSize);
      }

      if (options.size) {
        icon.size = this.createSize(options.size);
      }

      return icon;
    }
  }, {
    key: "createSymbol",
    value: function createSymbol(options) {
      var icon = {
        path: options.path,
        rotation: options.rotation,
        scale: options.scale,
        fillColor: options.fillColor,
        fillOpacity: options.fillOpacity,
        strokeColor: options.strokeColor,
        strokeOpacity: options.strokeOpacity,
        strokeWeight: options.strokeWeight
      };

      if (options.anchor) {
        icon.anchor = this.createPoint(options.anchor);
      }

      if (options.labelOrigin) {
        icon.labelOrigin = this.createPoint(options.labelOrigin);
      }

      return icon;
    }
  }, {
    key: "getEnum",
    value: function getEnum(name, value) {
      return (0, _has3.default)(this.maps[name], value) ? (0, _get3.default)(this.maps[name], value) : value;
    }
  }]);

  return MapContext;
}();