"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createListeners = exports.createListener = exports.getChangedProps = exports.isEqualProps = undefined;

var _union2 = require("lodash/union");

var _union3 = _interopRequireDefault(_union2);

var _keys2 = require("lodash/keys");

var _keys3 = _interopRequireDefault(_keys2);

var _isEqualWith2 = require("lodash/isEqualWith");

var _isEqualWith3 = _interopRequireDefault(_isEqualWith2);

var _isFunction2 = require("lodash/isFunction");

var _isFunction3 = _interopRequireDefault(_isFunction2);

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// eslint-disable-next-line consistent-return
var isEqualPropsCustomizer = function isEqualPropsCustomizer(a, b) {
  // Do not compare react nodes
  if (_react2.default.isValidElement(a) || _react2.default.isValidElement(b)) {
    return a === b;
  }

  if (a && b && (0, _isFunction3.default)(a.equals)) {
    return a.equals(b);
  }
};

var isEqualProps = exports.isEqualProps = function isEqualProps(a, b) {
  return (0, _isEqualWith3.default)(a, b, isEqualPropsCustomizer);
};

var getChangedProps = exports.getChangedProps = function getChangedProps(prev, next) {
  var prevKeys = (0, _keys3.default)(prev);
  var nextKeys = (0, _keys3.default)(next);
  var allKeys = (0, _union3.default)(prevKeys, nextKeys);
  var hasDiff = false;
  var diff = {};

  allKeys.forEach(function (key) {
    if (!isEqualProps(prev[key], next[key])) {
      hasDiff = true;

      diff[key] = next[key];
    }
  }, {});

  return hasDiff ? diff : null;
};

var createListener = exports.createListener = function createListener(getHandler) {
  return function (x) {
    var fn = getHandler();

    if (fn) {
      fn(x);
    }
  };
};

var createListeners = exports.createListeners = function createListeners(events, getHandler) {
  return (0, _keys3.default)(events).map(function (handler) {
    var event = events[handler];

    return [event, createListener(function () {
      return getHandler(handler);
    })];
  });
};